/*----------------------------------------------------------------------*/
/* Match is a routine to match a file name against a pattern, providing	*/
/* a "wild card" matching that is a little more powerful than that of	*/
/* MS-DOS.  In MS-DOS, the "equal any number of any character" 			*/
/* character, "*", actually applies to the end of the string only.  For	*/
/* example, the pattern "*abc.*" would actually match ALL files that	*/
/* have an extension.  Using Match(), the same pattern would only match	*/
/* files that had an extension and had a name that ended in "abc".		*/
/* Match() can also handle patterns that contain more than one "*" such	*/
/* as "*abc*" which would match any file name that contained the letter	*/
/* triad "abc" anywhere in the name.  As with MS-DOS, a pattern that	*/
/* does NOT contain a "." is assumed to end in ".*", i.e matches file	*/
/* name without an extension or with any extension.						*/

#include <stdlib.h>
#include <string.h>

#ifdef PROF
	#include "pchrt.h"
#endif

 int
Match (char *Str, char *P) {
	char I_Pat[13];
	char *Pat = I_Pat;

#ifdef PROF
	t_entry(3);
#endif
	strcpy(I_Pat, P);
	if (strchr(I_Pat, '.') == NULL && strchr(Str, '.') != NULL)
		strcat(I_Pat, ".*");
	while (*Str != '\0') {
		if (*Str == *Pat || *Pat == '?') {
			Str++; Pat++;
			}
		else if (*Pat == '*') {
			Pat = &Pat[strspn(Pat, "*")];
			if (*Pat == '\0') {
#ifdef PROF
				t_exit(3);
#endif
				return(1);
				}
			Str = &Str[strcspn(Str, Pat)];
			}
		else {
#ifdef PROF
			t_exit(3);
#endif
			return(0);
			}
		}
	if (*Pat != '\0' && *Pat != '*') {
#ifdef PROF
		t_exit(3);
#endif
		return(0);
		}
#ifdef PROF
	t_exit(3);
#endif
	return(1);
	}